//
//  File:  I2CSample.h
//
#ifndef __I2CSAMPLE_H
#define __I2CSAMPLE_H

#ifdef __cplusplus
extern "C" {
#endif


#define IOCTL_I2C_SET_SLAVE_ADDRESS     \
    CTL_CODE(FILE_DEVICE_UNKNOWN, 0x0200, METHOD_BUFFERED, FILE_ANY_ACCESS)

//------------------------------------------------------------------------------

#define IOCTL_I2C_SET_SUBADDRESS_MODE     \
    CTL_CODE(FILE_DEVICE_UNKNOWN, 0x0201, METHOD_BUFFERED, FILE_ANY_ACCESS)


__inline BOOL SetSlaveAddress(HANDLE hI2C, DWORD address, DWORD mode)
{
    BOOL rc;
    rc = DeviceIoControl(
        hI2C, IOCTL_I2C_SET_SLAVE_ADDRESS, &address, sizeof(address), NULL, 0,
        NULL, NULL
        );

    rc = DeviceIoControl(
        hI2C, IOCTL_I2C_SET_SUBADDRESS_MODE, &mode, sizeof(mode), NULL, 0,
        NULL, NULL
        );

    return rc;
}


__inline DWORD
WriteI2C(
    HANDLE hI2C,
    UINT8  subaddr,
    VOID*  pBuffer,
    DWORD  count,
    DWORD *pWritten
    )
{
    SetFilePointer(hI2C, subaddr, NULL, FILE_BEGIN);
    return WriteFile(hI2C, pBuffer, count, pWritten, NULL);
}

//-----------------------------------------------------------------------------

__inline DWORD
ReadI2C(
    HANDLE hI2C,
    UINT8  subaddr,
    VOID*  pBuffer,
    DWORD  count,
    DWORD *pRead
    )
{
    SetFilePointer(hI2C, subaddr, NULL, FILE_BEGIN);
    return ReadFile(hI2C, pBuffer, count, pRead, NULL);
}


#ifdef __cplusplus
}
#endif

#endif